package com.brilliance;

import com.brilliance.swift.SwiftTransfer;
import com.brilliance.swift.vo.SwiftTranslationReport;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;
import org.apache.commons.io.FileUtils;
import org.junit.Test;

import java.io.File;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class MxXsdValidator {

    @Test
    public void testPacs008001() {
        File file = FileUtils.toFile(Mx2MtTest.class.getResource("/swiftXml/Pacs00800108.xml"));
        boolean flag = SwiftTransfer.validateMx(file);
        System.out.println(flag);
    }

    @Test
    public void test() throws IOException {
        File file = FileUtils.toFile(Mx2MtTest.class.getResource("/swiftXml/MxPacs00800108.xml"));
        System.out.println(SwiftTransfer.fetchFinFromMixMessage(file));
    }


    @Test
    public void generateAppHdrXsd() throws Exception {
        String str="LE345678901234567812";
        Pattern pattern=Pattern.compile("[A-Z0-9]{18,18}[0-9]{2,2}");
        Matcher m = pattern.matcher(str);
        System.out.println(m.find());
    }

    @Test
    public void tagTest() throws IOException {
        //File file = FileUtils.toFile(Mx2MtTest.class.getResource("/swiftTxt/MT103.txt"));
        File file = FileUtils.toFile(Mx2MtTest.class.getResource("/swiftXml/Pacs00800108.xml"));

        String s = FileUtils.readFileToString(file, "utf-8");
        System.out.println(getMxInfoByTag(s,"13C"));

    }

    public static Object getMxInfoByTag(String swiftISOXml,String tagName) throws IOException {
        SwiftTranslationReport swiftTranslationReport = SwiftTransfer.mx2MtPlus(swiftISOXml, null, null);
        System.out.println(swiftTranslationReport.getMessage());
        System.out.println(swiftTranslationReport.getMtType());
        System.out.println(swiftTranslationReport.getMxType());
        AbstractMT abstractMT= AbstractMT.parse(swiftTranslationReport.getMessage());
        Tag tag = abstractMT.getSwiftMessage().getBlock4().getTagByName(tagName);
        return tag.getValue();

    }
}
