package com.brilliance;

import com.brilliance.swift.util.XmlUtil;
import org.apache.commons.io.FileUtils;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.junit.Test;

import java.io.File;
import java.util.Map;

public class ParseISOTest {
    @Test
    public void testParseIsoXml() throws Exception {
        File file = FileUtils.toFile(ParseISOTest.class.getResource("/swiftXml/NcPacs00800108.xml"));
        String xmlStr = FileUtils.readFileToString(file);
        Document document = DocumentHelper.parseText(xmlStr);
        Map<String, String> parentElementMaps = XmlUtil.getParentElementMaps(document);
        System.out.println("isoMaps="+parentElementMaps);
        String bodyParentElementName = parentElementMaps.get("EndToEndId");
        String endToEndId = XmlUtil.getXmlNodeValue(document, bodyParentElementName + ".EndToEndId");
        System.out.println("endToEndId="+endToEndId);
        String ownrefParentElentName=parentElementMaps.get("InstrId");
        String ownref=XmlUtil.getXmlNodeValue(document,ownrefParentElentName+".InstrId");
        System.out.println("ownref="+ownref);
        String valueDateParentElementName=parentElementMaps.get("IntrBkSttlmDt");
        String valueDate=XmlUtil.getXmlNodeValue(document,valueDateParentElementName+".IntrBkSttlmDt");
        System.out.println("valueDate="+valueDate);
        //ownref我行参考号
        //othref他行参考号


        //参数 xmlPath报文路径 收发报标识flg 返回Map对象
    }
}
